import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, ViewChild, Output, Input, NgModule } from '@angular/core';
import { catchError, EMPTY } from 'rxjs';
import * as i1 from '@angular/common/http';
import { CommonModule } from '@angular/common';

class ProxyService {
    constructor(httpClient) {
        this.httpClient = httpClient;
        this.openReport = false;
    }
    createConnection() {
        let request = new Object();
        request.method = "POST";
        request.url = "";
        request.headers = {};
        request.responseType = "text";
        request.readyState = 1;
        request.status = 0;
        request.responseText = null;
        request.statusText = null;
        request.id = null;
        request.open = (method, url) => {
            request.method = method;
            request.url = url;
        };
        request.setRequestHeader = (key, value) => {
            request.headers[key] = value;
        };
        request.abort = () => {
        };
        request.onreadystatechange = () => { };
        request.send = (data) => {
            let formData;
            if (typeof data == 'object') {
                formData = new FormData();
                Object.keys(data).forEach(key => formData.append(key, data[key]));
            }
            let needGet = data && data["stiweb_action"] === "Resource";
            let observable;
            if (needGet) {
                observable = this.httpClient.get(request.url, formData !== null && formData !== void 0 ? formData : data).pipe(catchError((error) => {
                    return this.catchError(error, request);
                }));
            }
            else {
                observable = this.httpClient.post(request.url, formData !== null && formData !== void 0 ? formData : data, { responseType: request.responseType }).pipe(catchError((error) => {
                    return this.catchError(error, request);
                }));
            }
            observable.subscribe(data => {
                request.readyState = 4;
                let resultData = needGet ? JSON.stringify(data) : data;
                if (request.responseType == "text")
                    request.responseText = resultData;
                else
                    request.response = resultData;
                request.status = 200;
                request.onreadystatechange();
            });
        };
        return request;
    }
    ;
    catchError(error, request) {
        alert(JSON.stringify(error));
        request.status = error.status;
        request.statusText = error.statusText;
        request.responseText = error.error;
        request.readyState = 4;
        request.onreadystatechange();
        return EMPTY;
    }
    error(message) {
    }
    export(data) {
    }
    email(data) {
    }
    print(data) {
    }
    design() {
    }
    postParametersFunction(data) {
        return this.postParametersFunction_ ? this.postParametersFunction_(data) : {};
    }
}
ProxyService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ProxyService, deps: [{ token: i1.HttpClient }], target: i0.ɵɵFactoryTarget.Injectable });
ProxyService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ProxyService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ProxyService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i1.HttpClient }]; } });

class StimulsoftDesignerComponent {
    constructor(proxy) {
        this.proxy = proxy;
        /**
         * Occurs when designer loaded
         */
        this.designerLoaded = new EventEmitter();
        this.id = 'aDesigner' + (Math.random() * 10000000).toString();
        this.loaded = false;
    }
    ngOnDestroy() {
        var _a, _b, _c;
        if (this.chartScripts) {
            this.head.removeChild(this.chartScripts);
        }
        let options = (_c = (_b = (_a = this.designerEl.nativeElement) === null || _a === void 0 ? void 0 : _a.firstChild) === null || _b === void 0 ? void 0 : _b.jsObject) === null || _c === void 0 ? void 0 : _c.options;
        try {
            clearTimeout(options.timerAjax);
        }
        catch (_d) { }
        try {
            clearTimeout(options.timerUpdateCache);
        }
        catch (_e) { }
        try {
            clearTimeout(options.timerAutoSave);
        }
        catch (_f) { }
    }
    ngOnInit() {
        this.addScript();
    }
    ngOnChanges(changes) {
        this.addScript();
    }
    addScript() {
        if (this.chartScripts) {
            this.head.removeChild(this.chartScripts);
        }
        this.chartScripts = document.createElement('Script');
        this.chartScripts.setAttribute('type', 'text/javascript');
        this.chartScripts.src = this.requestUrl;
        this.chartScripts.addEventListener('load', () => {
            if (!this.loaded) {
                try {
                    const options = new Stimulsoft.Designer.StiDesignerOptions();
                    this.loaded = true;
                    setTimeout(() => {
                        this.designerLoaded.next(null);
                    });
                    this.showDesigner();
                }
                catch (_a) { }
            }
        });
        this.head.appendChild(this.chartScripts);
    }
    showDesigner() {
        const options = new Stimulsoft.Designer.StiDesignerOptions();
        if (this.width) {
            options.width = this.width;
        }
        if (this.height) {
            options.height = this.height;
        }
        this.designer = new Stimulsoft.Designer.StiDesigner(options, 'StiDesigner', false);
        this.proxy.postParametersFunction_ = this.postParametersFunction;
        this.designerEl.nativeElement.proxy = this.proxy;
        this.designer.renderHtml(this.designerEl.nativeElement);
    }
    get head() {
        return document.getElementsByTagName('head')[0];
    }
}
StimulsoftDesignerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: StimulsoftDesignerComponent, deps: [{ token: ProxyService }], target: i0.ɵɵFactoryTarget.Component });
StimulsoftDesignerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.3.0", type: StimulsoftDesignerComponent, selector: "stimulsoft-designer-angular", inputs: { requestUrl: "requestUrl", width: "width", height: "height", postParametersFunction: "postParametersFunction" }, outputs: { designerLoaded: "designerLoaded" }, providers: [ProxyService], viewQueries: [{ propertyName: "designerEl", first: true, predicate: ["designer"], descendants: true }], usesOnChanges: true, ngImport: i0, template: `
    <div #designer [attr.id]="id">
      <ng-content></ng-content>
    </div>
  `, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: StimulsoftDesignerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'stimulsoft-designer-angular', template: `
    <div #designer [attr.id]="id">
      <ng-content></ng-content>
    </div>
  `, providers: [ProxyService] }]
        }], ctorParameters: function () { return [{ type: ProxyService }]; }, propDecorators: { designerEl: [{
                type: ViewChild,
                args: ['designer']
            }], designerLoaded: [{
                type: Output
            }], requestUrl: [{
                type: Input
            }], width: [{
                type: Input
            }], height: [{
                type: Input
            }], postParametersFunction: [{
                type: Input
            }] } });

class StimulsoftDesignerModule {
}
StimulsoftDesignerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: StimulsoftDesignerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
StimulsoftDesignerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.3.0", ngImport: i0, type: StimulsoftDesignerModule, declarations: [StimulsoftDesignerComponent], imports: [CommonModule], exports: [StimulsoftDesignerComponent] });
StimulsoftDesignerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: StimulsoftDesignerModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: StimulsoftDesignerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [StimulsoftDesignerComponent],
                    imports: [
                        CommonModule
                    ],
                    exports: [StimulsoftDesignerComponent]
                }]
        }] });

/*
 * Public API Surface of stimulsoft-designer-angular
 */

/**
 * Generated bundle index. Do not edit.
 */

export { StimulsoftDesignerComponent, StimulsoftDesignerModule };
//# sourceMappingURL=stimulsoft-designer-angular.mjs.map
